<template>
  <div class="background">
    <div class="container">
      <navbar></navbar>
      <h1 class="pt-3">Choose your quote category</h1>
      <label
        class="pb-5"
        for="range"
      >Decide what rating your quotes should have from 1 to 5</label>
      <b-form-input
        ref="slider"
        id="ranger"
        v-model="value"
        type="range"
        min="1"
        max="5"
        step="1"
      ></b-form-input>
      <div class="mt-2 pb-3">Your quotes will be rated between {{ value -1 }} and {{ value }}</div>
      <div class="overflow-auto">
        <b-table
          id="my-table"
          striped
          hover
          responsive
          :items="filteredQuotes"
          :fields="fields"
          :per-page="perPage"
          :current-page="currentPage"
          :busy="loading"
          caption-top
          small
          @row-clicked="myRowClickHandler"
        >
          <template v-slot:table-caption>{{caption}}</template>
          <template v-slot:table-busy>
            <div class="text-center text-danger my-2">
              <b-spinner class="align-middle"></b-spinner>
              <strong>Loading...</strong>
            </div>
          </template>
        </b-table>
        <b-pagination
          v-model="currentPage"
          :total-rows="filteredQuotesLength"
          :per-page="perPage"
          pills
          aria-controls="my-table"
          align="center"
          class="fixstyle"
        ></b-pagination>
      </div>
    </div>
    <Footer></Footer>
  </div>
</template>

<script>
import Restclient from '../services/Restclient'
import Navbar from '@/components/Navbar.vue'
import Footer from '@/components/Footer.vue'

export default {
  name: 'categories',
  components: {
    Navbar,
    Footer
  },
  data () {
    return {
      value: 3,
      restclient: new Restclient(),
      quotes: [],
      perPage: 7,
      currentPage: 1,
      fields: [
        {
          key: 'author',
          sortable: true
        },
        {
          key: 'en',
          label: 'Quote',
          sortable: true
        },
        {
          key: 'rating',
          sortable: true,
        }
      ],
      loading: true,
      caption: 'This are decent quotes'
    }
  },
  created: async function () {
    this.quotes = await this.restclient.getAllQuotes()
    this.loading = false
  }, computed: {
    filteredQuotes () {
      return this.quotes.filter(quote => quote.rating <= this.value && quote.rating >= this.value - 1)
    }, filteredQuotesLength () {
      return this.filteredQuotes.length
    }
  },
  methods: {
    myRowClickHandler (record, index) {
      this.$router.push({ name: 'detail', params: { id: record.id } })
    }
  },
  watch: {
    value: function (value) {
      switch (value) {
        case '1':
          this.caption = 'Well, those quotes wont be any good'
          break
        case '2':
          this.caption = 'You sure you wanna get those quotes?'
          break
        case '3':
          this.caption = 'This is starting to look really good!'
          break
        case '4':
          this.caption = 'Those are some of the best, but you can go do better than this,..'
          break
        case '5':
          this.caption = 'You have reached the best quotes on the planet.'
          break
        default:
      }
    }
  }
}
</script>
<style scoped>
.background {
  min-height: 850px;
  background-color: #f2f2f2;
}
@media screen and (max-width: 991px) {
  h1 {
    font-size: 25px;
  }
}
</style>